package xyz.lychee.lagfixer.libs.adventure.text;

import java.util.stream.Stream;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.examination.ExaminableProperty;

public interface ScoreComponent extends BuildableComponent<ScoreComponent, Builder>, ScopedComponent<ScoreComponent> {
   @NotNull String name();

   @Contract(
      pure = true
   )
   @NotNull ScoreComponent name(final @NotNull String name);

   @NotNull String objective();

   @Contract(
      pure = true
   )
   @NotNull ScoreComponent objective(final @NotNull String objective);

   /** @deprecated */
   @Deprecated
   @Nullable String value();

   /** @deprecated */
   @Deprecated
   @Contract(
      pure = true
   )
   @NotNull ScoreComponent value(final @Nullable String value);

   default @NotNull Stream<? extends ExaminableProperty> examinableProperties() {
      return Stream.concat(Stream.of(ExaminableProperty.of("name", this.name()), ExaminableProperty.of("objective", this.objective()), ExaminableProperty.of("value", this.value())), BuildableComponent.super.examinableProperties());
   }

   public interface Builder extends ComponentBuilder<ScoreComponent, Builder> {
      @Contract("_ -> this")
      @NotNull
      @NotNull Builder name(final @NotNull String name);

      @Contract("_ -> this")
      @NotNull
      @NotNull Builder objective(final @NotNull String objective);

      /** @deprecated */
      @Deprecated
      @Contract("_ -> this")
      @NotNull
      @NotNull Builder value(final @Nullable String value);
   }
}
